#!/usr/bin/perl

use strict;
use warnings;

use lib ('../');

use Test::More tests => 5;

use Logaholic::Log::Domlog;

note('domains_to_qr()');
{
    my $csv       = 'dave.com,david.com, lild.com,foo.bar';
    my $domain_qr = Logaholic::Log::Domlog::domains_to_qr($csv);

    ok( 'david.com' =~ $domain_qr, 'fqdn.tld is a match' );
    ok( 'foo' !~ $domain_qr, 'fqdn (sans.tld) is not a match' );

    ok( 'http://david.com' !~ $domain_qr,
        'domains are anchored: adding schema creates non-match' );

    ok( ' lild.com' !~ $domain_qr,
        'all spaces are removed from values prior to regex creation' );
    ok( 'lild.com' =~ $domain_qr,
        'all spaces are removed from values prior to regex creation' )
}
