<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This is the master report class. All other reports should be childen of this parent class
* it is assumed that this is included somewhere where common.inc.php is also included 
*/
include_once("common.inc.php");
include_once("top.php");

#include Classes
include_once("includes/datamanager.php");

if(!$session->isAdmin() && $validUserRequired){
	echoWarning("You don't have permission to access datamanager.","margin:10px;");
	exit();
}

$reqFrom = @mktime(0,0,0,$_REQUEST["fmonth"],$_REQUEST["fday"],$_REQUEST["fyear"]);
$reqTo = @mktime(23,59,58,$_REQUEST["tmonth"],$_REQUEST["tday"],$_REQUEST["tyear"]);
?>
<style type='text/css'>
#Grid { width: 960px; color: #333; margin: 0 auto; text-align: center; }
#Grid #importGrid { text-align: left; border: 1px solid silver; width: 470px; float: right; margin-bottom: 20px; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
#Grid #importGrid .list-header{ width: 100%; height: auto; border-bottom: 1px solid silver; }
#Logs { height: 450px; overflow-x: hidden; overflow-y: auto; padding: 0; margin: 0; width: 100%; list-style-type: none; background: #999; text-shadow: 0 1px 0 #FFFFFF; -moz-text-shadow: 0 1px 0 #FFFFFF; -webkit-text-shadow: 0 1px 0 #FFFFFF; }
#Logs li { width: 470px; height: 28px; line-height: 28px; border-top: 1px solid #FFF; border-bottom: 1px solid silver; background-color: #E0E0E0; }
#Logs > li:last-child { box-shadow: 0 5px 5px #666; -moz-box-shadow: 0 5px 5px #666; -webkit-box-shadow: 0 5px 5px #666; border-bottom-left-radius: 4px; border-bottom-right-radius: 4px; -moz-border-bottomleft-radius: 4px; -moz-border-bottomright-radius: 4px; -webkit-border-bottom-left-radius: 4px; -webkit-border-bottom-right-radius: 4px; }
 { width: 458px; padding: 5px; color: #900; background-color: #F09090; height: auto; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; border: 1px solid #900; }
.error_message { width: 458px; padding: 5px; color: #900; background-color: #F09090; height: auto; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; border: 1px solid #900; }

#Logs { height: 420px; }
#Logs > li { height: auto; }
#Logs .logname { cursor: pointer; height: 28px; line-height: 28px; background-image: url(images/arrow_right_darkgrey_square.png); background-repeat: no-repeat; background-position: 5px center; background-color: #E0E0E0; padding: 0 5px 0 15px; border-bottom: 1px solid silver; }

#Logs li.open .logname { background-image: url(images/arrow_down_darkgrey_square.png); background-repeat: no-repeat; background-position: 5px center; }

.all-logs .checkbox,
#Logs .logname .checkbox { cursor: pointer; width: 12px; height: 12px; float: right; margin: 8px 20px 0 0; border: 1px solid silver; background-color: #F9F9F9; border-radius: 2px; -moz-border-radius: 2px; -webkit-border-radius: 2px; }
.all-logs .checkbox:hover,
#Logs .logname .checkbox:hover { border: 1px solid #333; background-color: #FFF; }
.all-logs .checkbox .checked,
#Logs .logname .checkbox .checked { width: 10px; height: 10px; margin: 1px 0 0 1px; border-radius: 1px; -moz-border-radius: 1px; -webkit-border-radius: 1px; }
.all-logs .checkbox:hover .checked,
#Logs .logname .checkbox:hover .checked { background-color: #FFBB00; }
.all-logs.selected .checkbox .checked,
#Logs .logname.selected .checkbox .checked { background: url(images/gradient_bg_blue.png) repeat-x top left #1970B4; }
#Logs li.includes { border-top: 1px solid #FF0; border-bottom: 1px solid #CC0; }
#Logs li.includes .logname { background-color: #FFBB00; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; }
#Logs li.includes.open { border-bottom: 0; }

#Logs .monthcontent { display: none; width: 100%; padding: 0; margin: 0; list-style-type: none; }
#Logs li.open .monthcontent { display: block; }
#Logs .monthcontent li { cursor: move; width: 450px; background-color: #F0F0F0; padding: 0 5px 0 15px; }
#Logs .monthcontent li.added { background-color: #C0FFC0; }
#Logs .monthcontent li.disabled { cursor: default; }
#Logs .monthcontent li .import-log { float: right; color: #1970B4; text-decoration: none; margin-right: 20px; }
#Logs .monthcontent li .import-log:hover { text-decoration: underline; }

#Logs .monthcontent li .deleted { margin-left: 1ex; }
#Logs .monthcontent li .reinstall { float: right; color: #1970B4; text-decoration: none; margin-right: 20px; }
#Logs .monthcontent li .reinstall:hover { text-decoration: underline; }

#Logs > li:last-child .monthcontent li:last-child { border-bottom-left-radius: 4px; border-bottom-right-radius: 4px; -moz-border-bottomleft-radius: 4px; -moz-border-bottomright-radius: 4px; -webkit-border-bottom-left-radius: 4px; -webkit-border-bottom-right-radius: 4px; }

.button_wrapper { width: 100px; border: 1px solid #24364C; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; float: right; margin: 0 5px; }
.button_wrapper.commit-install { background-color: #2B4C74; display: block; color: #FFF; padding: 5px 10px; text-align: center; text-decoration: none; border: 1px solid #2D4F7D; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
.button_wrapper.commit-install:hover { background-color: #14274A; }

#output-container{ height:400px; overflow-y: auto }


#manual-imex{ display:none; }
</style>
<script style="text/javascript">
$(document).ready( function() {	
	$(".logname .checkbox").live("click", function(ev) { // Check / Uncheck a month
		if($(this).parent().hasClass("selected") == true) {
			$(this).parent().removeClass("selected"); // Check a month
		} else {
			$(this).parent().addClass("selected"); // Check a month
		}
	});
	
	$(".logname:not(.checkbox, .checked)").click(function(ev) { // Show / Hide a profile's content
		if($(this).next(".monthcontent").is(":hidden") == true) {
			$(this).parent().addClass("open"); // Show the content
		} else {
			$(this).parent().removeClass("open"); // Hide the content
		}
	});
	
	$("#imex-checkbox").click( function() {
		if($('#imex-checkbox').is(':checked')){
			$("#manual-imex").show();
		} else {
			$("#manual-imex").hide();
		}
	});
});
</script>
<div id="Grid">
	<div style="float:left; width:470px; text-align:left;">
		<!-- AUTO EXPORT SETTINGS -->
		<h2>Data Manager Settings</h2>
		<?php
		#SET SETTINGS
		if(isset($_REQUEST["setSettings"])) {
			#save settings to profileSettings
			setProfileData($profile->profilename,$profile->profilename.".datamanagersettings",$_REQUEST["daterangelimit"]);
		}		
		$currentSetting = getProfileData($profile->profilename,$profile->profilename.".datamanagersettings",0);		
		
		?>
		<form>
		<table width='300'>
			<tr>
				<td>
					Max daterange in database:
				</td>
				<td>
					<?php					
					echo "<select name='daterangelimit'>";
						if($currentSetting == 0){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='0' {$sel}>No Limit</option>";
						if($currentSetting == 1){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='1' {$sel}>1 ". _MONTH ."</option>";
						if($currentSetting == 2){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='2' {$sel}>2 ". _MONTH ."</option>";
						if($currentSetting == 3){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='3' {$sel}>3 ". _MONTH ."</option>";
						if($currentSetting == 4){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='4' {$sel}>4 ". _MONTH ."</option>";
						if($currentSetting == 5){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='5' {$sel}>5 ". _MONTH ."</option>";
						if($currentSetting == 6){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='6' {$sel}>6 ". _MONTH ."</option>";
						if($currentSetting == 12){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='12' {$sel}>12 ". _MONTH ."</option>";
						
					echo "</select>";
					?>
				</td>
			</tr>
		</table>
		<br/>
		<input type='hidden' name='conf' value="<?php echo $profile->profilename; ?>"/>
		<input class="button_wrapper commit-install" type='submit' name='setSettings' value='Save Settings' style='float: left; font-size:14px;' />
		<input class="button_wrapper commit-install" type='submit' name='runSettings' value='Run Manager Now' style='width:150px; float: left; font-size:14px;' />
		</form>
		<br/><br/><br/>
		<!-- #IMPORT / EXPORT -->
		<div id='manual-imex'>
		<h2><?php echo "Import / Export date range from <font color=red>{$profile->profilename}</font>"; ?></h2>
		<form>
			<?php DateSelector($from,$to); ?>
			<input type='hidden' name='conf' value="<?php echo $profile->profilename; ?>"/><br/>
			<input class="button_wrapper commit-install" type='submit' name='export' value='Export' style='float: left; font-size:14px;' />
			<input class="button_wrapper commit-install" type='submit' name='import' value='Import' style='float: left; font-size:14px;' />
		</form>
		</div>
		<br/><br/><br/>
		<div id="output-container">
			<?php	
			#EXPORT
			if(isset($_REQUEST["export"])){
				#collect data from daterange and export.
				$dataManager = new DataManager();
				$dataManager->Export($profile,$reqFrom,$reqTo);	
			}
			#IMPORT
			if(isset($_REQUEST["import"])) {
				#import selected daterange
				$dataManager = new DataManager();
				$dataManager->Import($profile,$reqFrom,$reqTo);
			}
			#RUN SETTINGS
			if(isset($_REQUEST["runSettings"])) {
				setProfileData($profile->profilename,$profile->profilename.".datamanagersettings",$_REQUEST["daterangelimit"]);		
				$currentSetting = getProfileData($profile->profilename,$profile->profilename.".datamanagersettings",0);		
				
				$dataManager = new DataManager();
				$dataManager->ClearDatabase($profile,$currentSetting);
			}
			?>
		</div>
	</div>
	<?php
	#IMPORT
	$dir = "{$profile->datamanagerDir}{$profile->profilename}/log";
	$logFiles = array();
	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			$prev_dropdown = "";
			while (($file = readdir($dh)) !== false) {
				if($file !== "." && $file !== "..") {							
					$month = explode(".",$file);
					$month = $month[0];
					$month = mktime(0,0,0,substr($month,4,-2),substr($month,6,7),substr($month,0,4));
					$month = date("F Y",$month);							
					$logFiles[$month][] = $file;
				}
			}
			closedir($dh);
		}
	}	
	?>
	<div id='importGrid'>
		<form>	
			<div class='list-header'>			
				<p style="margin:5px 10px"><b>Log File Overview</b></p>
			</div>
			<ul id='Logs'>
				<?php 
				foreach($logFiles as $m => $files) {	
					echo "<li class='includes'>";
						echo "<div class='logname selected'>";
							echo "<span class='name'>{$m}</span>";
						echo "</div>";
						echo "<ul class='monthcontent'>";
						$i = 0;
						foreach($files as $file) {
							echo "<li class='disabled' rel='{$i}'>";
								echo "<span class=''>{$file}</span>";
							echo "</li>";
							$i ++;
						}
						echo "</ul>";
					echo "</li>";
				}
				?>
			</ul>
		</form>
		<p style='margin:0; padding:5px;'><input type='checkbox' id='imex-checkbox' /><b>Manually Export / Import Logfiles</b></p>
	</div>
</div>