<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This is the master report class. All other reports should be childen of this parent class
* it is assumed that this is included somewhere where common.inc.php is also included 
*/

include_once(logaholic_dir()."logparser.inc.php");

include_once(logaholic_dir()."components/import/import.php");

Class DataManager {
	var $print;
	var $set_time_limit;
	
	function __contruct() {
		$this->print = 1;
		$this->set_time_limit = 86400;
	}

	function AutoManager($profile){
		global $db,$force,$skiptime;
		
		if($force === true){
			return;
		}
		
		$setting = getProfileData($profile->profilename,$profile->profilename.".datamanagersettings",getGlobalSetting("datamanagersettings",0));
		if($setting == 0) {
			return;
		}else {
			
			$q = $db->Execute("SELECT MIN(timestamp) as mindate, MAX(timestamp) as maxdate FROM {$profile->tablename}");
			$data = $q->FetchRow();
			$max = $data["maxdate"];
			$min = $data["mindate"];
			
			$del_to = mktime(0,0,0,date("m",$max)-$setting,01,date("Y",$max)) - 1;
			
			if(empty($min) || empty($del_to)){
				return;
			}
			
			# if we are importing data that is older than the current min entry in database, we don't want to tigger datamanager during this update run			
			if (isset($skiptime)) { 
				if ($skiptime < $min) {
					return;
				}
			}	
			
			if( $min < $del_to ){
				// echo "AutoManager says datamanager would have run ( $min < $del_to )";
				// return;
				$this->ClearDatabase($profile, $setting);
				$this->cleanLogStorage($profile);
			} else {
				// echo "AutoManager says datamanager has nothing to do ( $min < $del_to )";
			}
			return;
		}
	}
	
	function createReportDataFiles($from,$to){
		global $reports;
		
		if( date("Y m d",$to) ==  date("Y m d",time())) {
			$to = mktime(23,59,59,date("m",$to),date("d",$to)-1,date("Y",$to));	
		}
		
		foreach($reports as $k => $v){
			$start = time();
			$r = new $reports[$k]["ClassName"]();
			if($v['Distribution'] == 'Unlisted') {
				continue;
			}
			$r->label = constant($k);		
			$r->UpdateStats($from,$to,2);	
			//$this->LogProcess("Memory usage is now ". memory_get_usage());
		}
	}
	
	function getTables() {
		global $profile;
		
		# Get an array containing all needed tables for the current profile.
		$tables = array();
		$tables[] = array('table' => $profile->tablename_urls , 'field' => 'url', 'sfield' => 's.url');
		$tables[] = array('table' => $profile->tablename_urlparams , 'field' => 'params', 'sfield' => 's.params');
		$tables[] = array('table' => $profile->tablename_referrers , 'field' => 'referrer', 'sfield' => 's.referrer');
		$tables[] = array('table' => $profile->tablename_refparams , 'field' => 'params', 'sfield' => 's.refparams');
		$tables[] = array('table' => $profile->tablename_keywords , 'field' => 'keywords', 'sfield' => 's.keywords');
		$tables[] = array('table' => $profile->tablename_useragents , 'field' => 'useragent', 'sfield' => 's.useragentid');
		$tables[] = array('table' => $profile->tablename_visitorids , 'field' => 'visitorid', 'sfield' => "s.visitorid");
		
		return $tables;
	}
	
	function took($start) {				
		$secs = time() - $start;		
		$hours = str_pad(floor($secs / (60 * 60)),2,'0',STR_PAD_LEFT);
		$divisor_for_minutes = $secs % (60 * 60);
		$minutes = str_pad(floor($divisor_for_minutes / 60),2,'0',STR_PAD_LEFT);
		$divisor_for_seconds = $divisor_for_minutes % 60;
		$seconds = str_pad(ceil($divisor_for_seconds),2,'0',STR_PAD_LEFT);
		return "{$hours}:{$minutes}:{$seconds} ($secs secs)";
	}
	
	function ClearDatabase($profile,$months = 0) {
		global $db,$DatabaseName, $validUserRequired, $session, $skiptime;
		$this->print = 1;
		# No database Limit set, so nothing happens to the database.
		if($months == 0){
			return false;
		}
		$start_time=time();
		ob_start();
		
		$q = $db->Execute("SELECT MIN(timestamp) as mindate, MAX(timestamp) as maxdate FROM {$profile->tablename}");
		$data = $q->FetchRow();
		$max = $data["maxdate"];
		$min = $data["mindate"];	

		# Set the timestamp to where the data must be deleted.
		$del_to = mktime(0,0,0,date("m",$max)-$months,01,date("Y",$max)) - 1;
		$range = $max - $del_to;	
	
		if ($min >= $del_to) {
				$this->LogProcess("ClearDatabase says datamanager has nothing to do ( $min < $del_to )");
				return;
		} else {
				$this->LogProcess( "ClearDatabase says datamanager would have run ( $min < $del_to )");
		}
		
		$time = mktime(0,0,0,date("m",$min),date("d",$min),date("Y",$min));
		$export = array();
		while($time < $del_to){
			if (!file_exists("{$profile->datamanagerDir}{$profile->profilename}/log/". date("Ymd",$time).".gz")) {
				$export[] = $time;
			}			
			$time = $time + 86400;
		}
		
		foreach($export as $k => $v ){
			$f = mktime(0,0,0,date("m",$v),date("d",$v),date("Y",$v));
			$t = mktime(23,59,59,date("m",$v),date("d",$v),date("Y",$v));
			$this->Export($profile, $f, $t, 1);
			$this->StopOrContinue();
		}		
		
		#export DataFiles
		$start = time();
		$this->createReportDataFiles($min,$del_to);
		$this->LogProcess( "<br/> CREATING DATA FILES TOOK: ". $this->took($start) . "<br/>");
		$this->StopOrContinue();
		#The main table
		
		#create Temp Main Table	
		$this->LogProcess( "Duplicating table {$profile->tablename}...");
		lgflush();
		createMainProfileTable($profile->tablename."_temp");
		createMainProfileTable($profile->tablename_crawl."_temp");
		
		$main_tables[] = $profile->tablename;
		$main_tables[] = $profile->tablename_crawl;
		
		# this is what we have to do for the  main and crawl tables
		foreach($main_tables as $table) {		
			$select = "SELECT * FROM {$table} WHERE timestamp >= $del_to";		
			$insert = "INSERT INTO {$table}_temp {$select}";
			$drop = "DROP TABLE IF EXISTS {$table}";
			$rename = "RENAME TABLE {$table}_temp TO {$table}";
			
			# Insert Data into temp Main Table
			# disable indexes on the copy so our insert is faster
			$db->Execute("ALTER TABLE {$table}_temp DISABLE KEYS");
			$this->LogProcess( "Inserting data into {$table}_temp..");
			lgflush();
			$start = time();
			$db->Execute($insert);
			$rows = $db->Affected_Rows();
			$db->Execute("ALTER TABLE {$table}_temp ENABLE KEYS");
			$this->LogProcess( "Took: " . $this->took($start) . "</br>");
			
			#Return the amount of rows affected		
			$this->LogProcess( "Affected $rows rows from {$table}.<br/>");
			lgflush();
			
			# Delete the old profile table
			$this->LogProcess( "Dropping  old table {$table}..");
			lgflush();					
			$db->Execute($drop);			
			
			# Rename the temp table to the original name
			$this->LogProcess( "Renaming {$table}_temp to {$table}..");
			lgflush();		
			$db->Execute($rename);	
			
			# sometimes the table crashes (seen in only one case, but persistent), so let's do a rapair table just to be sure
			$db->Execute("REPAIR TABLE $table");
		}
		
		$merge_table = $profile->MainCrawlMerge();
		
		$tables = $this->getTables();
		# this is what we do for all the subtables		
		foreach($tables as $table){			
			# set up all the queries we need to do for each table			
			$create_index = "ALTER TABLE {$profile->tablename} ADD INDEX (".substr($table["sfield"],2).")";
			$create_index2 = "ALTER TABLE {$profile->tablename_crawl} ADD INDEX (".substr($table["sfield"],2).")";
			
			$dropoldtemp = "DROP TABLE IF EXISTS {$table["table"]}_temp";
			$create = "CREATE TABLE {$table["table"]}_temp LIKE {$table["table"]}";
			$select =  "SELECT DISTINCT t.* FROM {$table["table"]} as t, {$merge_table} as s WHERE t.id = {$table["sfield"]}";
			$insert = "INSERT INTO {$table["table"]}_temp {$select}";
			$drop = "DROP TABLE IF EXISTS {$table["table"]}";
			$rename = "RENAME TABLE {$table["table"]}_temp TO {$table["table"]}";
			
			$drop_index = "ALTER TABLE {$profile->tablename} DROP INDEX ".substr($table["sfield"],2);
			$drop_index2 = "ALTER TABLE {$profile->tablename_crawl} DROP INDEX ".substr($table["sfield"],2);
			
			# this is an exception for the visitorids table
			if ($table["table"]==$profile->tablename_visitorids) {
				$this->LogProcess( "Adding temporary index to $profile->tablename...");
				lgflush();
				$start = time();
				$db->Execute($create_index);
				$db->Execute($create_index2);
				$merge_table = $profile->MainCrawlMerge();
				$this->LogProcess( "Took: " . $this->took($start) . "<br />");
			}
			
			# drop old temp table if it exists, and create a new one
			$db->Execute($dropoldtemp);
			$this->LogProcess( "Duplicating table {$table["table"]}...");
			lgflush();
			$db->Execute($create);

			# disable indexes on the copy so our insert is faster
			$db->Execute("ALTER TABLE {$table["table"]}_temp DISABLE KEYS");
		
			# insert the data we want to keep into the temp table
			$this->LogProcess( "Inserting data into  {$table["table"]}_temp..");
			lgflush();	
			$start = time();		
			$db->Execute($insert);			
			$rows = $db->Affected_Rows();
			$this->LogProcess( "Affected $rows rows from {$table["table"]}<br />");
			
			# enable the keys
			$db->Execute("ALTER TABLE {$table["table"]}_temp ENABLE KEYS");			
			$this->LogProcess( "Took: " . $this->took($start) . "<br />");			
			lgflush();
			
			# delete the original table
			$this->LogProcess( "Dropping  old table {$table["table"]}..");
			lgflush();			
			$db->Execute($drop);
			
			# rename temp to the original name
			$this->LogProcess( "Renaming {$table["table"]}_temp to {$table["table"]}..");
			lgflush();			
			$db->Execute($rename);	

			if ($table["table"]==$profile->tablename_visitorids) {
				$this->LogProcess( "Dropping temporary index on $profile->tablename...");
				lgflush();
				$start = time();
				$db->Execute($drop_index);
				$db->Execute($drop_index2);
				$merge_table = $profile->MainCrawlMerge();
				$this->LogProcess( "Took: " . $this->took($start) . "<br />");
			}
		}
		# the conversions table is a copy of info in main table so we can just delete the date range
		$db->Execute("DELETE FROM $profile->tablename_conversions WHERE timestamp < $del_to");
				
		# we're done
		$this->LogProcess( "Finished Clearing Database. The whole process took ".$this->took($start_time)."<br />");
	}
	
	function CreateTmpTxtFileFromGzFile($path,$file){
		$totmem = substr(ini_get('memory_limit'),0,-1); 
		if (!$totmem) {
			$totmem=(8*1024*1024);    
		} else {
			$totmem=($totmem*1024*1024);
		}
		$totmem= intval(($totmem*0.9));
		$availmem = $totmem - memory_get_usage();
		
		if($availmem >  (filesize($path.$file.".gz") * 10)) {
			ob_start(); 			
			readgzfile($path.$file.".gz");
			$contents = ob_get_clean();
		}
		
		# Write the data in the temp txt file.
		$fp = fopen($path.$file.'.txt', 'w');
		fwrite($fp, $contents);		
		fclose($fp);		
		
		return $file. ".txt";
	}
	
	function Import($profile,$from,$to,$print = 1){
		global $db, $vnum , $databasedriver, $reports;
		
		set_time_limit($this->set_time_limit);
		
		$importer = new Import();
		
		$basepath = "{$profile->datamanagerDir}{$profile->profilename}/log/";
		$time =  mktime(00, 00, 00,date("m",$from), date("d",$from), date("Y",$from));
		$oriTo = $to;
		while($time <= $oriTo) {
			$to = $time + 86399;
			
			$log_file = date("Ymd",$time);

			if(!file_exists($basepath.$log_file.".gz")){
				$time = $time + 86400;
				continue;
			}
			
			$new_log_file = $this->CreateTmpTxtFileFromGzFile($basepath,$log_file);
			
			if($print == 1){
				$this->LogProcess( "Importing: <b>". date("d M Y",$time) ."</b><br/>");
			}
			
			$importer->print = $print;
			
			# Import the data parsed by perl with Load Data Infile in MySQL
			$importer->ImportLog($basepath.$new_log_file);
			
			# Insert the data in the corresponding tables.
			$importer->insertIDs();
			
			# Insert the visitor ID's
			$importer->insertVisitorIDs();
			
			# Insert the ID's in the main table.
			$importer->insertNormalized();
			
			# Add internal referrer detection.
			$importer->UpdateInternalReferrers();
			
			# Add useragent detection
			$importer->UpdateUseragents();
			
			# Move the crawler traffic to a table of it's own
			$importer->separateBots();
			
			# Copy the conversions to a table of it's own
			$importer->copyConversions();
			
			# We're done with our log table; delete it.
			$db->Execute("DROP TABLE IF EXISTS {$profile->tablename}log");
			
			
			unlink($basepath.$new_log_file);
			
			if($print == 1){
				$this->LogProcess( "<br/>");
			}
			
			$time = $time + 86400;
		}		
	}	
	function Export($profile, $from, $to,$print = 0){
		global $db;
		# Export the .gzipped backup file.
		set_time_limit($this->set_time_limit);
		
		$q = $db->Execute("SELECT MIN(timestamp) as mindate, MAX(timestamp) as maxdate FROM {$profile->tablename}");
		$data = $q->FetchRow();
		if ($from < $data["mindate"] && $to < $data["mindate"]) {
			echo "The date range you chose is not available in the database. Database data spans from ".date("Y-m-d",$data["mindate"]) . " to ".date("Y-m-d",$data["maxdate"]);
			return;
		}
		
		if($from < $data["mindate"]){
			$from = $data["mindate"];
		}		
		if($to > $data["maxdate"]){
			$to = $data["maxdate"];
		}		
		
		//echo "exporting from ".date("Ymd",$from) . " to ".date("Ymd",$to);
		// we want to grab data here from both the main table and the crawl table, so lets make a merge table
		$export_table = $profile->MainCrawlMerge();  
		
		
		$time =  mktime(00, 00, 00,date("m",$from), date("d",$from), date("Y",$from)); 
		$oriTo = $to;
		while($time <= $oriTo) {
			
			$to = $time + 86399;
			# get all data from the database within the daterange
			$query = "SELECT a.timestamp, 
						v.ipnumber AS ipnumber, 
						u.url AS url, 
						up.params AS params, 
						a.status, a.bytes, 
						r.referrer AS referrer,
						k.keywords as keywords,
						rp.params AS refparams, 
						b.useragent AS useragent,
						v.visitorid as visitorid,
						a.sessionid as sessionid,
						a.crawl as crawl,
						a.country as country

					FROM {$export_table} as a, 
						{$profile->tablename_visitorids} AS v, 
						{$profile->tablename_urls} AS u, 
						{$profile->tablename_urlparams} AS up, 
						{$profile->tablename_referrers} AS r,
						{$profile->tablename_keywords} as k,
						{$profile->tablename_refparams} AS rp, 
						{$profile->tablename_useragents} AS b 

					WHERE a.timestamp >= {$time} 
						and a.timestamp <= {$to} 
						AND (a.visitorid = v.id
						AND a.url = u.id 
						AND a.params = up.id 
						AND a.referrer = r.id
						and a.keywords = k.id
						AND a.refparams = rp.id 
						AND a.useragentid = b.id)

					ORDER BY a.timestamp";
			
			$bupfile = "{$profile->datamanagerDir}{$profile->profilename}/log/". date("Ymd",$time).".gz";
			
			$dir_1 = "{$profile->datamanagerDir}{$profile->profilename}";
			$dir_2 = $dir_1."/log/";
			if(!file_exists($bupfile)) {
				if(!file_exists($dir_1)) {
					mkdir($dir_1);
					set_permissions($dir_1);
				}
				if(!file_exists($dir_2)) {
					mkdir($dir_2);
					set_permissions($dir_2);
				}
			} else {
				# if the file exists, we'll assume we only need to regenerate it if it is the last file, so check if the next file exists
				$test = "{$profile->datamanagerDir}{$profile->profilename}/log/". date("Ymd",($time+86400)).".gz";
				if(file_exists($test)) {
					$time = $time + 86400;
					//echo "skipping $bupfile<br>";
					continue;
				}
			}
						
			$fp = gzopen ($bupfile,"w");
			$buffer = "";
			
			$q = $db->Execute($query);
			while ($data=$q->FetchRow()) {
				if ($data["refparams"]=="?") {
					$data["refparams"]="-";
				}				
				
				$buffer = $data["ipnumber"]
				."|LWA|". "-"
				."|LWA|". "-"
				."|LWA|". $data["timestamp"]
				."|LWA|". ""
				."|LWA|". $data["url"] 
				."|LWA|". $data["status"]
				."|LWA|". $data["bytes"]
				."|LWA|". $data["referrer"]
				."|LWA|". $data["useragent"]
				."|LWA|". md5($data["useragent"])
				."|LWA|". "" 
				."|LWA|". $data["params"]				
				."|LWA|". $data["refparams"]
				."|LWA|". $data["keywords"]
				."|LWA|". $data["visitorid"]
				."|LWA|". $data["country"]
				."|LWA|". $data["crawl"]
				."|LWA|". $data["sessionid"]
				. "\n";
				
				gzwrite ($fp, $buffer);
			}
			gzclose ($fp);
			set_permissions($bupfile);

			$this->LogProcess("wrote file: $bupfile<br>");	
			//echo "wrote file: $bupfile<br>";
				
			@lgflush();
			$time = $time + 86400;
		}
	}
	
	# This function prints stuff to the update progress log.
	function LogProcess($message) {
		global $updatelog, $running_from_command_line;
		
		if(!empty($updatelog)) {
			fwrite($updatelog, $message."\n");
		} else {
			echoConsoleSafe($message."<br/>");
		}
		
		lgflush();			
		
	}
	
	function cleanLogStorage($profile){
		$bytes = $profile->datamanagerMaxStorage * 1024 * 1024;
	
		$dir = $profile->datamanagerDir.$profile->profilename."/log";
		if(!is_dir($dir)) {
			return;
		}
		$logs = array();
		$total = 0;
		
		foreach(glob($dir . '/*') as $logfile) {
			$date = explode("log/",str_replace(".gz", "",$logfile));
			$date = $date[1];
			$logs[$date]["file"] = $logfile;
			$logs[$date]["size"] = filesize($logfile);
			$total = $total + filesize($logfile);
		}		
		ksort($logs);
		
		if($bytes > $total) {
			return;
		}
		
		foreach($logs as $log){
			if($bytes > $total) {
				break;
			}
			unlink($log["file"]);
			$total = $total - $log["size"];
			
		}
		return;
	}
	
	
	# This function will stop the update process if a user has remotely turned on the stop flag (via UI)
	function StopOrContinue() {
		global $profile;
		if (getProfileData($profile->profilename, "{$profile->profilename}.stop_update", false) == 1) {
			$this->LogProcess("Error: user stopped process", false);
			# reset the stop flag
			setProfileData($profile->profilename, "{$profile->profilename}.stop_update", false);
			# We are done with Perl update; unflag it.
			setProfileData($profile->profilename, "{$profile->profilename}.update_running", 'no');			
			die();
		} else {
			return true;
		}
	}
}
?>	